// 아이디어
// numbers의 원소는 0 이상 1,000 이하입니다.
// 괜히 위와 같은 제한조건을 준 것이 아니다.
// 항상 완전탐색방식으로 오래 걸려서 시간초과가 발생하는 문제들은
// 완타로 푸는 것이 아니다.
// 그럼 여기서 생각해볼 수 있는 방식은
// 루프 한방으로 끝내야 한다는 것이다.
// 어떻게 하면 루프 한방으로 끝낼 수 있을까?
// 바로 전처리이다.
// 전처리로 바로 루프 한방으로 끝낼 수 있다.
// 전처리를 잘하는 것이 핵심
// 그 힌트는 numbers의 원소는 0 이상 1,000 이하입니다. 이라는 부분이다.
// 즉, 모든 숫자의 포맷을 저 단위로 맞추라는 것이다.
// 그리고 이러한 부분을 준 것이 또 하나의 힌트! numbers의 길이는 1 이상 100,000 이하입니다.
// 즉, 1000 * 100000 = 100000000 이다.
// 즉 1초에 1억번 연산을 의미한다.
// 따라서 1초컷으로 끝내라는 말이고, 루프 한방으로 끝내는 것이다.
// 중요 문제

function solution(numbers) {
  numbers = numbers.map((v) => "" + v);
  numbers.sort((a, b) => {
    if (+b[0] == +a[0]) return +(a + b) > +(b + a) ? -1 : 1;
    else return +b[0] - +a[0];
  });

  let ans = numbers.join("");
  return +ans == 0 ? "0" : ans;
}

// 레퍼렌스 코드
function solution(numbers) {
  let answer = numbers.sort((a, b) => `${b}${a}` - `${a}${b}`).join("");
  return answer[0] === "0" ? "0" : answer;
}

// sort 는 모든 조합을 해보면서 정렬하므로
// 이를 활용하면 쉽다.
// sort 는 버블 소팅처험 수행한다.
